;
; ************************************************************
; * Project Name: MP3Player
; * Author: Muset Dima
; * Date Started: 22/11/2008
; * Last Updated: 23/11/2008
; * Email: udu64@mail.ru
; * Version: 1.0 
; ************************************************************
;

;[ In main loop]
;MP_MOUSEHIT_1 = MouseHit(1)
;FlushMouse()

Global MP_IMG[15]
Global MP_MOUSEHIT_1
Global MP_FONT
Global MP_FULL_MODE
Global MP_SEEK_POS
Global MP_SEEK_ACTIVE
Global MP_CHANNEL_HANDLE
Global MP_CHANNEL
Global MP_VOLUME_POS = 62
Global MP_VOL_ACTIVE
Global MP_PLAY
Global MP_REPEAT
Global MP_SHUFFLE

Type MP_Files
	Field File$
	Field Name$
	Field Color_
End Type

Function CreateMP(iPatch$,mPatch$)
	MP_IMG[1] =  LoadImage(iPatch$+"IMG1.bmp")
	MP_IMG[2] =  LoadImage(iPatch$+"IMG2.bmp")
	MP_IMG[3] =  LoadImage(iPatch$+"IMG3.bmp")
	MP_IMG[4] =  LoadImage(iPatch$+"IMG4.bmp")
	MP_IMG[5] =  LoadImage(iPatch$+"IMG5.bmp")
	MP_IMG[6] =  LoadImage(iPatch$+"IMG6.bmp")
	MP_IMG[7] =  LoadImage(iPatch$+"IMG7.bmp")
	MP_IMG[8] =  LoadImage(iPatch$+"IMG8.bmp")
	MP_IMG[9] =  LoadImage(iPatch$+"IMG9.bmp")
	MP_IMG[10] = LoadImage(iPatch$+"IMG10.bmp")
	MP_IMG[11] = LoadImage(iPatch$+"IMG11.bmp")
	MP_IMG[12] = LoadImage(iPatch$+"IMG12.bmp")
	MP_IMG[13] = LoadImage(iPatch$+"IMG13.bmp")
	MP_IMG[14] = LoadImage(iPatch$+"IMG14.bmp")
	MP_IMG[15] = LoadImage(iPatch$+"IMG15.bmp")
	
	MP_FONT = LoadFont("Blitz",14)
	MP_FULL_MODE = 0
	
	If FileType(mPatch$) = 2
		FOLDER = ReadDir(mPatch$)
		Repeat 
			FILE$ = NextFile(FOLDER) 
	    	If FileType(mPatch$+FILE) = 1 Then
	    	    F$ = Right(FILE,4)
	    	    D$ = Right(FILE,3)
	    	    If F=".raw" Or F=".mod" Or F=".s3m" Or F=".mid" Or F=".rmi" Or F=".wav" Or F=".mp2" Or F=".mp3" Or F=".ogg" Or F=".wma" Or F=".asf" Or D=".xm" Or D=".it"
	    	    	MPF.MP_Files = New MP_Files
	     			MPF\File = mPatch$+FILE 
	            	MPF\Name = Left(FILE,33) 
	            EndIf 
		    EndIf 
		Until FILE = ""
		CloseDir FOLDER
	EndIf
End Function

Function UpdateMP()
    GR_W = GraphicsWidth()
    GR_H = GraphicsHeight()
    mx = MouseX()
	my = MouseY()
	SetFont MP_FONT
	DrawImage(MP_IMG[1],GR_W-300,GR_H-20)
	
	If mx>GR_W-295 And mx<GR_W-270 And my>GR_H-20 And my<GR_H
		DrawImage(MP_IMG[6],GR_W-295,GR_H-20)
		If MP_PLAY : DrawImage(MP_IMG[14],GR_W-295,GR_H-20)
		Else : DrawImage(MP_IMG[6],GR_W-295,GR_H-20) : EndIf
		PS = 1
		If MP_MOUSEHIT_1 MP_PLAY = Not MP_PLAY
		If MP_PLAY 
			If MP_CHANNEL<>0 ResumeChannel MP_CHANNEL
			If MP_CHANNEL<>0 Then 
				If ChannelPlaying(MP_CHANNEL)=0
					MPF.MP_Files = Object.MP_Files(MP_CHANNEL_HANDLE)
					If MPF<>Null 
						MP_CHANNEL = PlayMusic(MPF\File)
						MP_CHANNEL_HANDLE = Handle(MPF)
						MPF\Color_ = 1
						MP_PLAY = 1
                	EndIf 
                EndIf 
			ElseIf MP_CHANNEL=0
				MPF.MP_Files = First MP_Files
				If MPF<>Null 
	            	MP_CHANNEL = PlayMusic(MPF\File)
					MP_CHANNEL_HANDLE = Handle(MPF)
					MPF\Color_ = 1
					MP_PLAY = 1
                EndIf
			EndIf 
		Else
			If MP_CHANNEL<>0 PauseChannel MP_CHANNEL
		EndIf 
	ElseIf mx>GR_W-272 And mx<GR_W-247 And my>GR_H-20 And my<GR_H
	    DrawImage(MP_IMG[7],GR_W-272,GR_H-20)
	     If MP_MOUSEHIT_1 And MP_CHANNEL<>0 
			StopChannel(MP_CHANNEL)
			MP_PLAY = 0
		EndIf 
	ElseIf mx>GR_W-241 And mx<GR_W-227 And my>GR_H-20 And my<GR_H
	    DrawImage(MP_IMG[8],GR_W-241,GR_H-16)
	    If MP_MOUSEHIT_1 MP_REPEAT = Not MP_REPEAT
	ElseIf mx>GR_W-226 And mx<GR_W-213 And my>GR_H-20 And my<GR_H
	    DrawImage(MP_IMG[9],GR_W-226,GR_H-16)
		If MP_MOUSEHIT_1 MP_SHUFFLE= Not MP_SHUFFLE
	ElseIf mx>GR_W-201 And mx<GR_W-180 And my>GR_H-20 And my<GR_H
	    DrawImage(MP_IMG[10],GR_W-201,GR_H-20)
	    If MP_MOUSEHIT_1
	    	MPF.MP_Files = Object.MP_Files(MP_CHANNEL_HANDLE)
	        If MPF<>Null MPF = Before MPF
	        If MPF<>Null  
            	If MP_CHANNEL<>0 StopChannel(MP_CHANNEL)
	            MP_CHANNEL = PlayMusic(MPF\File)
				MP_CHANNEL_HANDLE = Handle(MPF)
				MPF\Color_ = 1
				MP_PLAY = 1
			Else  
			    MPF.MP_Files = Last MP_Files
			    If MPF<>Null 
			    	If MP_CHANNEL<>0 StopChannel(MP_CHANNEL)
	            	MP_CHANNEL = PlayMusic(MPF\File)
					MP_CHANNEL_HANDLE = Handle(MPF)
					MPF\Color_ = 1
					MP_PLAY = 1
			    EndIf 
	        EndIf 
	    EndIf
	ElseIf mx>GR_W-178 And mx<GR_W-158 And my>GR_H-20 And my<GR_H
	    DrawImage(MP_IMG[11],GR_W-178,GR_H-20)
	    If MP_MOUSEHIT_1
	    	MPF.MP_Files = Object.MP_Files(MP_CHANNEL_HANDLE)
	        If MPF<>Null MPF = After MPF
	        If MPF<>Null  
            	If MP_CHANNEL<>0 StopChannel(MP_CHANNEL)
	            MP_CHANNEL = PlayMusic(MPF\File)
				MP_CHANNEL_HANDLE = Handle(MPF)
				MPF\Color_ = 1
				MP_PLAY = 1
			Else  
			    MPF.MP_Files = First MP_Files
			    If MPF<>Null 
			    	If MP_CHANNEL<>0 StopChannel(MP_CHANNEL)
	            	MP_CHANNEL = PlayMusic(MPF\File)
					MP_CHANNEL_HANDLE = Handle(MPF)
					MPF\Color_ = 1
					MP_PLAY = 1
			    EndIf 
	        EndIf 
	    EndIf
	EndIf
	If MP_REPEAT DrawImage(MP_IMG[8],GR_W-241,GR_H-16)
	If MP_SHUFFLE DrawImage(MP_IMG[9],GR_W-226,GR_H-16)
	If MP_PLAY And PS = 0 DrawImage(MP_IMG[15],GR_W-295,GR_H-20)
	
	xpos = (GR_W-130)+MP_VOLUME_POS
	DrawImage(MP_IMG[5],xpos,GR_H-18)
	If (mx>xpos And mx<xpos+10 And my>GR_H-18 And my<GR_H And MouseDown(1)) Or (MP_VOL_ACTIVE = 1 And MouseDown(1))
	    MP_VOLUME_POS = mx-(GR_W-125)
	    If MP_VOLUME_POS>62 MP_VOLUME_POS = 62
	    If MP_VOLUME_POS<0 MP_VOLUME_POS = 0
	    MP_VOL_ACTIVE = 1
	Else 
	    MP_VOL_ACTIVE = 0
	EndIf	
	
	If MP_CHANNEL<>0
		If MP_PLAY ChannelVolume MP_CHANNEL,MP_VOLUME_POS/62.0
		If ChannelPlaying(MP_CHANNEL)=0 And MP_PLAY
			If MP_SHUFFLE
				MPF.MP_Files = First MP_Files
				If MPF<>Null
					tr = 0
					Repeat 
						For MPF.MP_Files = Each MP_Files
							If Int(Rnd(1,5))=2
								Exit   
								tr = 1
							EndIf 
						Next
					Until tr=0
				
					If MPF<>Null
	        	    	MP_CHANNEL = PlayMusic(MPF\File)
						MP_CHANNEL_HANDLE = Handle(MPF)
						MPF\Color_ = 1
						MP_PLAY = 1
					EndIf
				Else
					MP_CHANNEL = 0
					MP_CHANNEL_HANDLE = 0
					MP_PLAY = 0 
				EndIf 
			Else
				MPF.MP_Files = Object.MP_Files(MP_CHANNEL_HANDLE) 
				MPF = After MPF
				If MPF<>Null
	        	    MP_CHANNEL = PlayMusic(MPF\File)
					MP_CHANNEL_HANDLE = Handle(MPF)
					MPF\Color_ = 1
					MP_PLAY = 1
				ElseIf MP_REPEAT
					MPF.MP_Files = First MP_Files
					If MPF<>Null
						MP_CHANNEL = PlayMusic(MPF\File)
						MP_CHANNEL_HANDLE = Handle(MPF)
						MPF\Color_ = 1
						MP_PLAY = 1
					EndIf 
				Else
				    MP_CHANNEL = 0
					MP_CHANNEL_HANDLE = 0
					MP_PLAY = 0
				EndIf
			EndIf 
		EndIf
	EndIf

	If MP_FULL_MODE
		DrawImage(MP_IMG[2],GR_W-300,GR_H-100)
		DrawImage(MP_IMG[3],GR_W-18,GR_H-12)
		
		ypos = (GR_H-85)+MP_SEEK_POS
	    DrawImage(MP_IMG[4],GR_W-23,ypos)
	    If (mx>GR_W-23 And mx<GR_W-1 And my>ypos And my<ypos+14 And MouseDown(1)) Or (MP_SEEK_ACTIVE = 1 And MouseDown(1))
	    	MP_SEEK_POS = my-(GR_H-78)
	        If MP_SEEK_POS>50 MP_SEEK_POS = 50
	        If MP_SEEK_POS<0  MP_SEEK_POS = 0
	        MP_SEEK_ACTIVE = 1
	    Else
	        MP_SEEK_ACTIVE = 0
	    EndIf
	
		CNT# = -5
		For MPF.MP_Files = Each MP_Files
			CNT = CNT + 1
	    Next
        PR# = 50.0/CNT
	    TEXTPOS# = -((MP_SEEK_POS/PR)*10)
		For MPF.MP_Files = Each MP_Files
			If TEXTPOS>-1 
			    If MPF\Color_ = 1 
			    	Color 200,0,0
	     			Text (GR_W-295),(GR_H-85)+TEXTPOS,MPF\Name
	            Else
	                Color 255,255,255
	     			Text (GR_W-295),(GR_H-85)+TEXTPOS,MPF\Name
	            EndIf 
	            If Handle(MPF)<>MP_CHANNEL_HANDLE MPF\Color_=0
	            If mx>GR_W-295 And mx<GR_W-30 And my>GR_H-85+TEXTPOS And my<GR_H-75+TEXTPOS And MP_MOUSEHIT_1
	                If MP_CHANNEL<>0 StopChannel(MP_CHANNEL)	
	                MP_CHANNEL = PlayMusic(MPF\File)
					MP_CHANNEL_HANDLE = Handle(MPF)
					MPF\Color_ = 1
					MP_PLAY = 1
	            EndIf
	        EndIf 
	        TEXTPOS = TEXTPOS+10
	        If TEXTPOS>50 Then Exit 
		Next 
	EndIf 
	
	If mx>GR_W-20 And mx<GR_W And my>GR_H-20 And my<GR_H 
		If MP_MOUSEHIT_1 MP_FULL_MODE = Not MP_FULL_MODE
		If MP_FULL_MODE
			DrawImage(MP_IMG[12],GR_W-19,GR_H-14)
		Else
		    DrawImage(MP_IMG[13],GR_W-19,GR_H-13)
		EndIf 
	EndIf
End Function 